'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transform = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var transform = exports.transform = function transform(importRelPath, filename) {
  var envs = arguments.length <= 2 || arguments[2] === undefined ? { production: 'prod', development: 'dev' } : arguments[2];
  var defaultEnv = arguments.length <= 3 || arguments[3] === undefined ? 'development' : arguments[3];

  var envExt = envs[process.env.NODE_ENV || defaultEnv];

  if (typeof envExt === 'undefined') {
    return;
  }

  var dirname = _path2.default.dirname(filename);
  var importedFilename = _path2.default.normalize(dirname + '/' + importRelPath);
  var importedExtname = _path2.default.extname(importedFilename);

  var envDirname = _path2.default.dirname(importedFilename);
  var envExtname = importedExtname || '.js';
  var envBasename = _path2.default.basename(importedFilename, envExtname);

  var envFilename = envDirname + '/' + envBasename + '.' + envExt + envExtname;

  _fs2.default.accessSync(envFilename);

  var newImportDirname = _path2.default.dirname(importRelPath);
  var newImportBasename = _path2.default.basename(importRelPath, importedExtname);
  return newImportDirname + '/' + newImportBasename + '.' + envExt + importedExtname;
};

exports.default = function (_ref) {
  var types = _ref.types;

  return {
    visitor: {
      ImportDeclaration: function ImportDeclaration(_ref2, _ref3) {
        var node = _ref2.node;
        var file = _ref3.file;
        var opts = _ref3.opts;

        try {
          node.source = types.stringLiteral(transform(node.source.value, file.opts.filename, opts.envMap, opts.defaultEnv));
        } catch (err) {
          // will use default import statement
        }
      }
    }
  };
};